# NWidgetToolbarContainer Class Reference

Full blown container to make it behave exactly as we want :). More...

Inheritance diagram for NWidgetToolbarContainer:

## Public Member Functions
bool | IsButton (WidgetType type) const
| Check whether the given widget type is a button for us.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | Draw (const Window *w)
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual const byte * | GetButtonArrangement (uint &width, uint &arrangable_count, uint &button_count, uint &spacer_count) const =0
| Get the arrangement of the buttons for the toolbar.
## Protected Attributes
uint | spacers
| Number of spacer widgets in this toolbar.
## Private Attributes
bool | visible [TBN_END]
| The visible headers.

## Detailed Description

Full blown container to make it behave exactly as we want :).

Definition at line 910 of file toolbar_gui.cpp.

## Member Function Documentation

bool NWidgetToolbarContainer::IsButton | ( | WidgetType | type | ) | const`[inline]`

Check whether the given widget type is a button for us.

Parameters:

  | type | the widget type to check

Returns:
  true if it is a button for us

Definition at line 925 of file toolbar_gui.cpp.

References WWT_IMGBTN, and WWT_IMGBTN_2.

Referenced by AssignSizePosition(), and SetupSmallestSize().

void NWidgetToolbarContainer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[inline, virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Reimplemented in NWidgetScenarioToolbarContainer.

Definition at line 930 of file toolbar_gui.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, NWidgetContainer::head, IsButton(), max(), NWidgetBase::next, NWID_SPACER, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::smallest_x, NWidgetBase::smallest_y, and spacers.

Referenced by NWidgetScenarioToolbarContainer::SetupSmallestSize().

void NWidgetToolbarContainer::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[inline, virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 960 of file toolbar_gui.cpp.

References NWidgetBase::AssignSizePosition(), NWidgetBase::current_x, NWidgetBase::current_y, GetButtonArrangement(), NWidgetContainer::head, IsButton(), max(), NWidgetBase::next, NWID_SPACER, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::prev, NWidgetBase::smallest_x, NWidgetBase::smallest_y, TBN_END, NWidgetBase::type, and visible.

void NWidgetToolbarContainer::Draw | ( | const Window * | w | ) | `[inline, virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1023 of file toolbar_gui.cpp.

References _dynlang, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetBase::Draw(), FILLRECT_CHECKER, GfxFillRect(), NWidgetContainer::head, NWidgetBase::next, NWID_SPACER, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::prev, NWidgetContainer::tail, TD_RTL, DynamicLanguages::text_dir, and visible.

NWidgetCore* NWidgetToolbarContainer::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[inline, virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1038 of file toolbar_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWID_SPACER, NWidgetBase::pos_x, NWidgetBase::pos_y, and visible.

virtual const byte* NWidgetToolbarContainer::GetButtonArrangement | ( | uint & | width,
|  | uint & | arrangable_count,
|  | uint & | button_count,
|  | uint & | spacer_count |
| ) |  |  | const`[pure virtual]`

Get the arrangement of the buttons for the toolbar.

Parameters:

  | width | the new width of the toolbar
  | arrangable_count | output of the number of visible items
  | button_count | output of the number of visible buttons
  | spacer_count | output of the number of spacers

Returns:
  the button configuration

Implemented in NWidgetMainToolbarContainer, and NWidgetScenarioToolbarContainer.

Referenced by AssignSizePosition().

The documentation for this class was generated from the following file:

- src/toolbar_gui.cpp